*-----------------------------------------------------------------------
*     Copyright (C) 2004 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE STFITR(UX, UY, TX, TY)
      INTEGER NXS, NYS
      PARAMETER(NW=@MAXNGRID)
      REAL UXS(NW), UYS(NW)
      REAL UXA(NX), UYA(NX)
      REAL TXA(NX,NY), TYA(NX,NY)
      REAL CX, CY, VX0, VY0
      INTEGER IUXINC, IUYINC
      LOGICAL LINIT
      DATA LINIT /.FALSE./
      SAVE

      IF (.NOT.LINIT) CALL MSGDMP('E','STFITR','NOT YET INITIALZED')

      II = IBLKGE(UXS,NXS,UX)
      I = MIN( MAX(1,II), NXS-1 )                     ! 0 -> 1; nxs -> nxs-1
      IF (II.EQ.NXS .AND. UXS(NXS).EQ.UX) II = NXS-1  ! to include the boundary

      JJ = IBLKGE(UYS,NYS,UY)
      J = MIN( MAX(1,JJ), NYS-1 )                     ! 0 -> 1; nys -> nys-1
      IF (JJ.EQ.NYS .AND. UYS(NYS).EQ.UY) JJ = NYS-1  ! to include the boundary

      CALL DCL_STGITP(I,J, TX11,TX21,TX12,TX22, TY11,TY21,TY12,TY22)

      P = (UX-UXS(I)) / (UXS(I+1)-UXS(I))
      Q = (UY-UYS(J)) / (UYS(J+1)-UYS(J))

      TX =   (1-P)*(1-Q)*TX11 + P*(1-Q)*TX21 + (1-P)*Q*TX12 + P*Q*TX22
      TY =   (1-P)*(1-Q)*TY11 + P*(1-Q)*TY21 + (1-P)*Q*TY12 + P*Q*TY22

      IF (II.EQ.0 .OR. II.EQ.NXS .OR. JJ.EQ.0 .OR. JJ.EQ.NYS) THEN
        CALL MSGDMP('W','STFITR','UX OR UY: OUT OF THE RANGE')
      ENDIF

      RETURN

C----------------------------------------------------------------
      ENTRY STIITR(TX, TY, UX, UY)
      CALL MSGDMP('E','STIITR','YET TO BE IMPLIMENTED')
      RETURN

C----------------------------------------------------------------
      ENTRY STCITR
      IF (.NOT.LINIT) CALL MSGDMP('E','STCITR','NOT YET INITIALZED')
      CALL STSTRN(50,CX,CY,VX0,VY0)
      RETURN

C----------------------------------------------------------------
      ENTRY STSITR(NX, NY, UXA,UYA, TXA,TYA, TXMIN,TXMAX,TYMIN,TYMAX)

      IF (NX.GT.NW) CALL MSGDMP('E','STSITR','WORKING AREA NOT ENOUGH')
      IF (NY.GT.NW) CALL MSGDMP('E','STSITR','WORKING AREA NOT ENOUGH')
      IF (NX.LT.2) CALL MSGDMP('E','STSITR','NX MUST BE >= 2')
      IF (NY.LT.2) CALL MSGDMP('E','STSITR','NY MUST BE >= 2')

      NXS = NX
      NYS = NY

      CALL GLRGET('RUNDEF',RUNDEF)

      IF (UXA(2).GT.UXA(1)) THEN
        IUXINC = 1
        UXS(1)=UXA(1)
        DO I=2,NX
          IF (UXA(I).LE.UXA(I-1)) THEN
            CALL MSGDMP('E','STSITR','UX IS NOT STRICTLY MONOTONIC*')
          ENDIF
          UXS(I)=UXA(I)
        ENDDO
      ELSE
        IUXINC = 0
        UXS(NX)=UXA(1)
        DO I=2,NX
          IF (UXA(I).GE.UXA(I-1)) THEN
            CALL MSGDMP('E','STSITR','UX IS NOT STRICTLY MONOTONIC')
          ENDIF
          UXS(NX-I+1)=UXA(I)
        ENDDO
      ENDIF

      IF (UYA(2).GT.UYA(1)) THEN
        IUYINC = 1
        UYS(1)=UYA(1)
        DO J=2,NY
          IF (UYA(J).LE.UYA(J-1)) THEN
            CALL MSGDMP('E','STSITR','UY IS NOT STRICTLY MONOTONIC*')
          ENDIF
          UYS(J)=UYA(J)
        ENDDO
      ELSE
        IUYINC = 0
        UYS(NY)=UYA(1)
        DO J=2,NY
          IF (UYA(J).GE.UYA(J-1)) THEN
            CALL MSGDMP('E','STSITR','UY IS NOT STRICTLY MONOTONIC')
          ENDIF
          UYS(NY-J+1)=UYA(J)
        ENDDO
      ENDIF
      CALL DCL_STSITP(RUNDEF, IUXINC,IUYINC, NX,NY, TXA,TYA, UXS,UYS)

      CALL SGQVPT(VXMIN,VXMAX,VYMIN,VYMAX)
      CX  = (VXMAX-VXMIN) / (TXMAX-TXMIN)
      VX0 = VXMIN - CX * TXMIN
      CY  = (VYMAX-VYMIN) / (TYMAX-TYMIN)
      VY0 = VYMIN - CY * TYMIN
      CALL STSTRN(50,CX,CY,VX0,VY0)

      LINIT = .TRUE.

      RETURN
      END
